--- old/usr/src/cmd/fm/fmdump/common/nvlrender.c	Tue Jan 29 00:40:56 2013
+++ new/usr/src/cmd/fm/fmdump/common/nvlrender.c	Tue Jan 29 00:40:56 2013
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2013, Joyent, Inc. All rights reserved.
  */
 
 /*
@@ -71,4 +72,17 @@
 	topo_hdl_strfree(thp, fmristr);
 
 	return (1);
+}
+
+/*
+ * Thin wrapper around libnvpair's inbuilt JSON routine.  Simply dumps the
+ * entire log record nvlist without any reformatting.
+ */
+int
+fmdump_print_json(fmd_log_t *lp, const fmd_log_record_t *rp, FILE *fp)
+{
+	nvlist_print_json(fp, rp->rec_nvl);
+	fprintf(fp, "\n");
+
+	return (0);
 }
